import random
from collections import OrderedDict

from corelibs import config, lazy as lz

CORELIBS_FOLDER = ".corelibs"

corelibs_path = lz._get_corelibs_path()
corelibs_root = lz.get_abspath(corelibs_path, CORELIBS_FOLDER)
corelibs_path_ico = lz.get_abspath(corelibs_path, r"gui\corelibs.ico")
user_corelibs_root = lz.get_abspath(lz.get_home(), CORELIBS_FOLDER)
user_corelibs_env_requirements_root = lz.get_abspath(user_corelibs_root, "env_backup")
user_corelibs_cache_root = lz.get_abspath(user_corelibs_root, "cache")

themes = OrderedDict()
themes.update({
    "Black": "Black",
    "Blue Mono": "BlueMono",
    "Blue Purple": "BluePurple",
    "Bright Colors": "BrightColors",
    "Brown Blue": "BrownBlue",
    "Dark": "Dark",
    "Dark 2": "Dark2",
    "Dark Amber": "DarkAmber",
    "Dark Black": "DarkBlack",
    "Dark Black 1": "DarkBlack1",
    "Dark Blue": "DarkBlue",
    "Dark Blue 1": "DarkBlue1",
    "Dark Blue 2": "DarkBlue2",
    "Dark Blue 3": "DarkBlue3",
    "Dark Blue 4": "DarkBlue4",
    "Dark Blue 5": "DarkBlue5",
    "Dark Blue 6": "DarkBlue6",
    "Dark Blue 7": "DarkBlue7",
    "Dark Blue 8": "DarkBlue8",
    "Dark Blue 9": "DarkBlue9",
    "Dark Blue 10": "DarkBlue10",
    "Dark Blue 11": "DarkBlue11",
    "Dark Blue 12": "DarkBlue12",
    "Dark Blue 13": "DarkBlue13",
    "Dark Blue 14": "DarkBlue14",
    "Dark Blue 15": "DarkBlue15",
    "Dark Blue 16": "DarkBlue16",
    "Dark Blue 17": "DarkBlue17",
    "Dark Brown": "DarkBrown",
    "Dark Brown 1": "DarkBrown1",
    "Dark Brown 2": "DarkBrown2",
    "Dark Brown 3": "DarkBrown3",
    "Dark Brown 4": "DarkBrown4",
    "Dark Brown 5": "DarkBrown5",
    "Dark Brown 6": "DarkBrown6",
    "Dark Brown 7": "DarkBrown7",
    "Dark Green": "DarkGreen",
    "Dark Green 1": "DarkGreen1",
    "Dark Green 2": "DarkGreen2",
    "Dark Green 3": "DarkGreen3",
    "Dark Green 4": "DarkGreen4",
    "Dark Green 5": "DarkGreen5",
    "Dark Green 6": "DarkGreen6",
    "Dark Green 7": "DarkGreen7",
    "Dark Grey": "DarkGrey",
    "Dark Grey 1": "DarkGrey1",
    "Dark Grey 2": "DarkGrey2",
    "Dark Grey 3": "DarkGrey3",
    "Dark Grey 4": "DarkGrey4",
    "Dark Grey 5": "DarkGrey5",
    "Dark Grey 6": "DarkGrey6",
    "Dark Grey 7": "DarkGrey7",
    "Dark Grey 8": "DarkGrey8",
    "Dark Grey 9": "DarkGrey9",
    "Dark Grey 10": "DarkGrey10",
    "Dark Grey 11": "DarkGrey11",
    "Dark Grey 12": "DarkGrey12",
    "Dark Grey 13": "DarkGrey13",
    "Dark Grey 14": "DarkGrey14",
    "Dark Purple": "DarkPurple",
    "Dark Purple 1": "DarkPurple1",
    "Dark Purple 2": "DarkPurple2",
    "Dark Purple 3": "DarkPurple3",
    "Dark Purple 4": "DarkPurple4",
    "Dark Purple 5": "DarkPurple5",
    "Dark Purple 6": "DarkPurple6",
    "Dark Purple 7": "DarkPurple7",
    "Dark Red": "DarkRed",
    "Dark Red 1": "DarkRed1",
    "Dark Red 2": "DarkRed2",
    "Dark Tan Blue": "DarkTanBlue",
    "Dark Teal": "DarkTeal",
    "Dark Teal 1": "DarkTeal1",
    "Dark Teal 2": "DarkTeal2",
    "Dark Teal 3": "DarkTeal3",
    "Dark Teal 4": "DarkTeal4",
    "Dark Teal 5": "DarkTeal5",
    "Dark Teal 6": "DarkTeal6",
    "Dark Teal 7": "DarkTeal7",
    "Dark Teal 8": "DarkTeal8",
    "Dark Teal 9": "DarkTeal9",
    "Dark Teal 10": "DarkTeal10",
    "Dark Teal 11": "DarkTeal11",
    "Dark Teal 12": "DarkTeal12",
    "Default": "Default",
    "Default 1": "Default1",
    "Default No More Nagging": "DefaultNoMoreNagging",
    "Green": "Green",
    "Green Mono": "GreenMono",
    "Green Tan": "GreenTan",
    "Hot Dog Stand": "HotDogStand",
    "Kayak": "Kayak",
    "Light Blue": "LightBlue",
    "Light Blue 1": "LightBlue1",
    "Light Blue 2": "LightBlue2",
    "Light Blue 3": "LightBlue3",
    "Light Blue 4": "LightBlue4",
    "Light Blue 5": "LightBlue5",
    "Light Blue 6": "LightBlue6",
    "Light Blue 7": "LightBlue7",
    "Light Brown": "LightBrown",
    "Light Brown 1": "LightBrown1",
    "Light Brown 2": "LightBrown2",
    "Light Brown 3": "LightBrown3",
    "Light Brown 4": "LightBrown4",
    "Light Brown 5": "LightBrown5",
    "Light Brown 6": "LightBrown6",
    "Light Brown 7": "LightBrown7",
    "Light Brown 8": "LightBrown8",
    "Light Brown 9": "LightBrown9",
    "Light Brown 10": "LightBrown10",
    "Light Brown 11": "LightBrown11",
    "Light Brown 12": "LightBrown12",
    "Light Brown 13": "LightBrown13",
    "Light Gray 1": "LightGray1",
    "Light Green": "LightGreen",
    "Light Green 1": "LightGreen1",
    "Light Green 2": "LightGreen2",
    "Light Green 3": "LightGreen3",
    "Light Green 4": "LightGreen4",
    "Light Green 5": "LightGreen5",
    "Light Green 6": "LightGreen6",
    "Light Green 7": "LightGreen7",
    "Light Green 8": "LightGreen8",
    "Light Green 9": "LightGreen9",
    "Light Green 10": "LightGreen10",
    "Light Grey": "LightGrey",
    "Light Grey 1": "LightGrey1",
    "Light Grey 2": "LightGrey2",
    "Light Grey 3": "LightGrey3",
    "Light Grey 4": "LightGrey4",
    "Light Grey 5": "LightGrey5",
    "Light Grey 6": "LightGrey6",
    "Light Purple": "LightPurple",
    "Light Teal": "LightTeal",
    "Light Yellow": "LightYellow",
    "Material 1": "Material1",
    "Material 2": "Material2",
    "Neutral Blue": "NeutralBlue",
    "Purple": "Purple",
    "Python": "Python",
    "Reddit": "Reddit",
    "Reds": "Reds",
    "Sandy Beach": "SandyBeach",
    "System Default": "SystemDefault",
    "System Default 1": "SystemDefault1",
    "System Default For Real": "SystemDefaultForReal",
    "Tan": "Tan",
    "Tan Blue": "TanBlue",
    "Teal Mono": "TealMono",
    "Topanga": "Topanga"
})

active_theme = None
active_theme_name = config.UI_THEME_NAME


def set_theme(theme_name=config.UI_THEME_NAME):
    global active_theme, active_theme_name

    if theme_name in ("random", "", None):
        _ = random.choice(range(len(themes)))
        active_theme = list(themes.items())[_][1]
        active_theme_name = list(themes.items())[_][0]
    else:
        active_theme = themes[theme_name]
